#!/usr/bin/env python
# csgoMP.  a csgo music player / soundboard for Linux
# (C) 2016 Adam Feakin csgomp@csparker.uk
# 
# I am not really a python person so there is probably a lot of thigs 
# wrong with this code, but it seems to be working so it can't be that bad.
#

import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk
import os
from ConfigParser import SafeConfigParser
#from subprocess import call


class Handler:
    def onDeleteWindow(self, *args):
        save_prefs()
        Gtk.main_quit(*args)

    def show_prefs_cb(self, button):
        # some options
        # csgo install path
        # keybinding for play/stop
        # choose max audio file length, cut if too long (ffmpeg -t option)
        print("Showing config window...")
        push_prefs()
        prefswin.show()

    def save_cfg_cb(self, button):
        print("Save cfg...")
        global ffmpeg_path, csgo_directory, max_audio_length, files_count
        csgo_cfg_path = csgo_directory + "/csgo/cfg"
        cfg_filename = csgo_cfg_path + "/csgomp.cfg"

        # delete exising file
        if os.path.isfile(cfg_filename) == True:
            print("Deleting old cfg")
            os.remove(cfg_filename)

        # make a new one
        with open(cfg_filename, "w") as f:
            f.write("alias +csgomp_play csgomp_start\n")
            f.write("alias -csgomp_play csgomp_stop\n")
            f.write("alias csgomp_start \"voice_inputfromfile 1; voice_loopback 1; +voicerecord\"\n")
            f.write("alias csgomp_stop \"-voicerecord; voice_loopback 0; voice_inputfromfile 0\"\n")
            # TODO: add a pref to set this bind key
            f.write("bind ' +csgomp_play\n")
            f.close()

        # TODO: add a popup to tell user to exec csgomp in console
        #show_cfg_load_popup()

    def prefs_ok_cb(self, button):
        print("Saving settings...")
        pull_prefs()
        save_prefs()
        prefswin.hide()

    def prefs_cancel_cb(self, button):
        print("Not saving settings")
        prefswin.hide()
    
    def add_file_cb(self, button):
        print("Show filesel...")
        # don't fetch and destroy here, just use run/show and hide
        resp = fileswin.run()
        if resp == 1:
            print("OK")
            filename = fileswin.get_filename()
            print("Filename is " + filename)
            liststore.append([filename])

            # debug: print what is in the list
            treeiter = liststore.get_iter_first()
            while treeiter != None:
                print(str(liststore[treeiter][0]))
                treeiter = liststore.iter_next(treeiter)

        elif resp == 2:
            print("CANCEL")

        fileswin.hide()

    def filesel_open_clicked_cb(self, button):
        print("Open")
        fileswin.destroy()

    def filesel_cancel_clicked_cb(self, button):
        print("Cancel")
        fileswin.destroy()

    def selection_changed_cb(self, selection):
        model, treeiter = selection.get_selected()
        global ffmpeg_path, csgo_directory, max_audio_length, files_count
        if treeiter != None:
            # update voice_input.wav to selected file
            wav_file = csgo_directory + "/voice_input.wav"
            if max_audio_length > 0:
                audio_len_flag = " -t " + str(max_audio_length) + " "
            else:
                audio_len_flag = ""

            # TODO: add an offset value too, use -ss option

            # needs -flags +bitexact so ffmpeg doesnt add metadata
            ffmpeg_opts = "-vn -acodec pcm_s16le -ar 22050 -ac 1 -f wav -flags +bitexact"
            # use -y option to force overwrite
            ffmpeg_cmd = ffmpeg_path + " -loglevel panic -y -i '" + model[treeiter][0] + "' " + audio_len_flag + ffmpeg_opts + " '" + wav_file + "'"

            print("cmd: " + ffmpeg_cmd)
            # delete any existing file, even though -y should overwrite anyway
            if os.path.isfile(wav_file):
                os.remove(wav_file)

            # why doesnt call work?
            #call([ffmpeg_path, ffmpeg_cmd])
            os.system(ffmpeg_cmd)

def push_prefs():
    # update prefs window with current values
    global ffmpeg_path, csgo_directory, max_audio_length, files_count
    builder.get_object("entry_ffmpeg_path").set_text(ffmpeg_path)
    builder.get_object("entry_csgo_dir").set_text(csgo_directory)
    builder.get_object("entry_audio_len").set_text(str(max_audio_length))

def pull_prefs():
    # get values from prefs boxes into variables
    global ffmpeg_path, csgo_directory, max_audio_length, files_count
    ffmpeg_path = builder.get_object("entry_ffmpeg_path").get_text()
    csgo_directory = builder.get_object("entry_csgo_dir").get_text()
    max_audio_length = int(builder.get_object("entry_audio_len").get_text())
    print(ffmpeg_path)



def load_prefs():
    global ffmpeg_path, csgo_directory, max_audio_length, files_count
    if os.path.isfile("config.ini") == False:
        print("No settings found")
        return

    # load prefs
    config = SafeConfigParser()
    config.read("config.ini")
    
    # ffmpeg_path
    ffmpeg_path = config.get("main", "ffmpeg_path")
    
    # csgo_directory
    csgo_directory = config.get("main", "csgo_directory")
    
    # max_audio_length
    max_audio_length = config.getint("main", "max_audio_length")

    # files_count
    files_count = config.getint("main", "files_count")

    # load files section
    i = 0
    while i < files_count:
        filename = config.get("files", "file"+str(i))
        print("Found " + filename)
        liststore.append([filename])
        i+=1

def save_prefs():
    # save prefs
    global ffmpeg_path, csgo_directory, max_audio_length, files_count
    print("Saving...")
    config = SafeConfigParser()
    config.read("config.ini")
    
    if config.has_section("main") == False:
        config.add_section("main")

    # ffmpeg_path
    config.set("main", "ffmpeg_path", ffmpeg_path)
    print(ffmpeg_path)
    
    # csgo_directory
    config.set("main", "csgo_directory", csgo_directory)
    print(csgo_directory)
    
    # max_audio_length
    config.set("main", "max_audio_length", str(max_audio_length))
    print(str(max_audio_length))


    # save files section
    if config.has_section("files") == False:
        config.add_section("files")
       
    treeiter = liststore.get_iter_first()
    files_count = 0
    while treeiter != None:
        filename = str(liststore[treeiter][0])
        config.set("files", "file"+str(files_count), filename)
        treeiter = liststore.iter_next(treeiter)
        files_count+=1

    # files_count
    config.set("main", "files_count", str(files_count))
    print(str(files_count))

    with open("config.ini", "w") as f:
        config.write(f)

# Main
# load the glade file
builder = Gtk.Builder()
builder.add_from_file("MainWindow.glade")
builder.connect_signals(Handler())

# and fetch the windows
mainwin = builder.get_object("window1")
mainwin.show_all()

fileswin = builder.get_object("filechooserdialog1")
prefswin = builder.get_object("prefs")

# create a liststore for the files list
liststore = Gtk.ListStore(str)

treeview = builder.get_object("treeview1")
treeview.set_model(liststore)
# and put a heading
treeview.append_column(Gtk.TreeViewColumn("Filename", Gtk.CellRendererText(), text=0))

# set some default values
ffmpeg_path = "/usr/bin/ffmpeg"
csgo_directory = os.path.expanduser("~/.local/share/Steam/SteamApps/common/Counter-Strike Global Offensive/")
max_audio_length = 0
files_count = 0

# load prefs
load_prefs()

Gtk.main()

